<template>
  <div v-if="editMode" :class="{ 'editable-field': true, 'alted': isAltPressed }">
    <!-- <pre>{{ config }}</pre> -->
    <!-- <div contenteditable="true" @input="update">{{ textfieldEditedData }}</div> -->
   <!-- {{ config }} -->
   <!-- {{ path }}
   {{ imageData }} -->
    <!-- <router-link :to="{ path: linkData.url }"><slot :bind="linkData"></slot></router-link> -->
    <check-na :field="imageEditedData">
      <v-popover offset="16" :open="showTooltip" trigger="manual" placement="top" @hide="showTooltip = false">
        <div @dragover.stop.prevent="dragFileOver" @dragenter="dragFileOver" @drop.stop.prevent="dropFile" @dragleave="dragFileLeave" class="dropzone" @dblclick="showTooltip = true">
          <div v-if="status === 'loading'">Loading...</div>
          <slot :image="imageEditedData || {}"></slot>
        </div>

        <template slot="popover">
          Alt: <editable-textfield :node="node" :path="[...path, 'alt']"></editable-textfield>
        </template>
      </v-popover>
    </check-na>
  </div>
  <div v-else-if="imageData">
    <!-- <img :src="imageData"> -->
    <slot :image="imageData || {}"></slot>
  </div>
  <div v-else>
    <slot></slot>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

import CheckNa from '@/components/Editable/Utils/CheckNa'

import EditableTextfield from '@/components/Editable/Fields/Inline/TextFieldInlineField'

export default {
  components: {
    CheckNa,
    EditableTextfield
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // options: {
    //   type: Object,
    //   required: false
    // }
  },

  data () {
    return {
      formData: new FormData(),
      imageId: null,
      showTooltip: false
      // rawKey: this.displayAsHTML ? (this.inputWithBr ? 'inner-html-w-br' : 'inner-html') : false
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      editMode: 'Y3TI/editMode',
      // getFieldConfig: 'Y3TI/getFieldConfig',
      isAltPressed: 'Y3TI/isAltPressed',
      getFileUploadStatus: 'Y3TI/getFileUploadStatus'
    }),
    // config () {
    //   return this.getFieldConfig({ node: this.node, path: this.path })
    // },

    status () {
      return this.imageId ? this.getFileUploadStatus(this.imageId) : null
    },

    imageData () {
      return _.get(this.node, this.path)
    },
    // textfieldEditedData () {
    //   return this.getEditedField({ node: this.node, path: this.path })
    // },

    imageEditedData () {
      // get () {
      // return _.get(this.$store.state.app.edited, this.editablePath)
      // return this.getEditedField({ node: this.node, path: this.path, raw: this.rawKey })
      return this.getEditedField({ node: this.node, path: this.path })
      // }
      // set (value) {
      //   this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value, raw: this.rawKey } })
      // }
    }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData',
      uploadEditableImage: 'Y3TI/uploadEditableImage'
    }),

    dragFileOver (event) {
      event.dataTransfer.dropEffect = 'copy'
      const container = event.target.closest('.dropzone')
      if (container) {
        container.classList.add('dragging')
      }
    },

    dragFileLeave (event) {
      const container = event.target.closest('.dropzone')
      if (container) {
        container.classList.remove('dragging')
      }
    },

    dropFile (event) {
      const container = event.target.closest('.dropzone')
      if (container) {
        container.classList.remove('dragging')
      }

      let fileList = event.dataTransfer.files
      if (!fileList.length) return

      this.formData.append('files[]', fileList[0], fileList[0].name)
      // Array.from(Array(fileList.length).keys()).map(x => {
      //   this.formData.append('file', fileList[x], fileList[x].name)
      // })

      let reader = new FileReader()

      reader.onload = () => {
        if (reader.result) {
          this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: { url: reader.result } } })
        }
      }

      reader.readAsDataURL(fileList[0])

      this.imageId = 'image-' + Date.now()
      this.uploadEditableImage({ data: { file: this.formData, id: this.imageId } }).then(({ data }) => {
        const currentValues = this.getEditedField({ node: this.node, path: this.path })
        const newValues = _.omitBy(_.get(data, ['images', 0], {}), _.isNil)

        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: _.assign({}, currentValues, newValues) } })
      }).then(() => {
        this.showTooltip = true
      }).catch((err) => {
        console.log(err)
      }).then(() => {
        this.formData = new FormData()
        this.imageId = null
        // event.target.value = ''
      })
    }
    // update (e) {
    //   this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: e.target.innerHTML, raw: this.rawKey } })
    // }
  }
}
</script>

<style lang="scss" scoped>
  .dragging {
    border: 2px dashed;
  }
</style>
